#
#  @file   CallManager.py
#  @author Francis Moreau
#  date    Wed Apr 16 2008
#  
#  Description:
#
#  Type your description here
#
#  Copyright (C) 2008 Paraxip Technologies.
#  All Rights Reserved.
#

from netborderPyInfra import Logger, TraceScope, UUID
from paraxip.infra.Assert import logAssert, isLogAssert

# Force declaration of class attributes in __init__ method
__pychecker__ = "initattr"

fileScopeLogger = Logger("netborder.CallManager.py")

class CallManager:
  def __init__(self):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "CallManager.__init__")

    self._Logger = Logger("netborder.CallManager.py")

    # _dictActiveCalls is a dictionary containing the list of active Call state
    # machines. The key is the CallId and the value is the instance of the Call
    # state machine itself.
    self._dictActiveCalls = {}
    
  def newCallId(self):
    return UUID().getAsString()

  def newDialogId(self):
    return UUID().getAsString()

  def countCallSM(self):
    return len(self._dictActiveCalls)

  def addCallSM(self, in_szCallId, in_CallSM):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "CallManager.addCallSM")

    logAssert(self._Logger, in_szCallId not in self._dictActiveCalls)

    self._dictActiveCalls[in_szCallId] = in_CallSM

  def isCallSMExist(self, in_szCallId):
    return in_szCallId in self._dictActiveCalls

  def getCallSM(self, in_szCallId):
    # Preventing an exception to be raised if the key already exist
    if (in_szCallId in self._dictActiveCalls):
      return self._dictActiveCalls[in_szCallId]
    return None

  def removeCallSM(self, in_szCallId):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "CallManager.removeCallSM")

    if (isLogAssert(self._Logger, in_szCallId in self._dictActiveCalls)):
      return
    del self._dictActiveCalls[in_szCallId]

  def getIterator(self):
    """
    cm = CallManager()
    it = cm.getIterator()
    for call in it:
      print call
    it.close()
    """
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "CallManager.getIterator")

    if (len(self._dictActiveCalls) > 0):
      for call in self._dictActiveCalls.itervalues():
        yield call

## !!MIRROR FILE, DO NOT MODIFY!!
