#
#  @file   EventProcessorManager.py
#  @author Francis Moreau
#  date    Wed Apr 16 2008
#  
#  Description:
#
#  Type your description here
#
#  Copyright (C) 2008 Paraxip Technologies.
#  All Rights Reserved.
#

from netborderPyInfra import Logger, TraceScope
from paraxip.infra.Assert import logAssert, isLogAssert

# Force declaration of class attributes in __init__ method
__pychecker__ = "initattr"

fileScopeLogger = Logger("netborder.EventProcessorManager.py")

class EventProcessorManager:
  def __init__(self):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "EventProcessorManager.__init__")

    self._Logger = Logger("netborder.EventProcessorManager.py")

    # _dictActiveEP is a dictionary containing the list of active Event
    # Processor. The key is the Event Processor Unique Id and the value
    # is the instance of the Event Processor itself.
    self._dictActiveEP = {}
    
  def addEP(self, in_szObjectId, in_EP):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "EventProcessorManager.addEP")

    logAssert(self._Logger, in_szObjectId not in self._dictActiveEP)

    self._dictActiveEP[in_szObjectId] = in_EP

  def getEP(self, in_szObjectId):
    # Preventing an exception to be raised if the key already exist
    if (in_szObjectId in self._dictActiveEP):
      return self._dictActiveEP[in_szObjectId]
    return None

  def removeEP(self, in_szObjectId):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "EventProcessorManager.removeEP")

    if (isLogAssert(self._Logger, in_szObjectId in self._dictActiveEP)):
      return
    del self._dictActiveEP[in_szObjectId]

  def getIterator(self):
    """
    ep = EventProcessorManager()
    it = ep.getIterator()
    for processor in it:
      print processor
    it.close()
    """
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "EventProcessorManager.getIterator")

    if (len(self._dictActiveEP) > 0):
      for ep in self._dictActiveEP.itervalues():
        yield ep

## !!MIRROR FILE, DO NOT MODIFY!!
