#
#  @file   InThreadCallbackImpl.py
#  @author Francis Moreau
#  date    Wed Apr 16 2008
#  
#  Description:
#
#  Type your description here
#
#  Copyright (C) 2008 Paraxip Technologies.
#  All Rights Reserved.
#

import paraxip.infra.PyLoggingFunctions as PyLoggingFunctions
from paraxip.infra.Assert import *
from netborderPyInfra import *
from SipCallEngineExtending import PyProxy

# Force declaration of class attributes in __init__ method
__pychecker__ = "initattr"

fileScopeLogger = Logger("netborder.InThreadCallbackImpl.py")

# Life cycle: - A proxy is created for keeping the Event Processor alive.
#             - The function receiving the callback is responsible to keep
#               the callback alive.

class InThreadCallbackImpl:
  def __init__(self, in_globalContext, in_eventProcessor):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "InThreadCallbackImpl.__init__")

    self._Logger = Logger("netborder.InThreadCallbackImpl.py")

    # Get the Event Processor unique Id
    self._strEventProcId = in_eventProcessor.getId()
    if (isLogAssert(self._Logger, self._strEventProcId is not None)):
      return

    # Get a Proxy on this Event Procesor
    self._proxy = in_globalContext.getProxy(self._strEventProcId)
    if (isLogAssert(self._Logger, self._proxy is not None)):
      return

  def enqueuePythonEvent(self, in_Event):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "InThreadCallbackImpl.enqueuePythonEvent")

    if (isLogAssert(self._Logger, self._proxy is not None)):
      return False

    return self._proxy.enqueuePythonEvent(in_Event)

## !!MIRROR FILE, DO NOT MODIFY!!
