#
#  @file   ObjectProxyCounted.py
#  @author Francis Moreau
#  date    Mon May 5 2008
#  
#  Description:
#
#  Type your description here
#
#  Copyright (C) 2008 Paraxip Technologies.
#  All Rights Reserved.
#

from netborderPyInfra import Logger, TraceScope
from paraxip.infra.Assert import logAssert, isLogAssert

# Force declaration of class attributes in __init__ method
__pychecker__ = "initattr"

fileScopeLogger = Logger("netborder.ObjectProxyCounted.py")

class ObjectProxyCounted:
  def __init__(self):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "ObjectProxyCounted.__init__")

    self._Logger = Logger("netborder.ObjectProxyCounted.py")

    self._proxyCount = 0

  def resetProxyCount(self):
    logAssert(self._Logger, self._proxyCount == 0)
    self._proxyCount = 0

  def incProxyCount(self):
    self._proxyCount = self._proxyCount + 1

  def decProxyCount(self):
    if (isLogAssert(self._Logger, self._proxyCount > 0)):
      return
    self._proxyCount = self._proxyCount - 1

  def isUniqueProxy(self):
    if (self._proxyCount <= 1):
      return True
    return False

  def getProxyCount(self):
    return self._proxyCount

## !!MIRROR FILE, DO NOT MODIFY!!
