#
#  Copyright (C) 2010 Paraxip Technologies.
#  All Rights Reserved.
#

from netborderPyInfra import TraceScope, Logger
from SipCallEngineExtending import PyTimeoutProcessor

fileScopeLogger = Logger("netborder.SMTimeoutProcessor.py")

#
# TimeoutProcessor
# This class is derived directly from C++
#

class SMTimeoutProcessor(PyTimeoutProcessor):
  def __init__(self, in_SM, in_event, in_timeoutCancelledEvent=None):
    PyTimeoutProcessor.__init__(self)
    
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger,
               "SMTimeoutProcessor.__init__")
    
    self._SM = in_SM
    
    self._event = in_event
    self._timeoutCancelledEvent = in_timeoutCancelledEvent
  
  def processTimeout(self, in_timeValueMs):
    __pychecker__ = 'unusednames=in_timeValueMs'
    
    return self._SM.processPythonEvent(self._event)
  
  def onTimeoutCancelled(self):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger,
               "SMTimeoutProcessor.onTimeoutCancelled")
    if self._timeoutCancelledEvent is not None:
      return self._SM.processPythonEvent(self._timeoutCancelledEvent)
    else:
      return True

## !!MIRROR FILE, DO NOT MODIFY!!
