import paraxip.infra.PyLoggingFunctions as PyLoggingFunctions
import netborderPyInfra

from InThreadCallbackImpl import InThreadCallbackImpl
from paraxip.sipua.internal.SipCallEngineEvent import SipCallEngineEvent 
from JSR309ClientAPIPythonModules import PyMediaEventListener

fileScopeLogger = \
    netborderPyInfra.Logger("netborder.jsr309")

#
#   JSR309 Event
# 
class JSR309Event(SipCallEngineEvent):
  def __init__(self, in_szDestObjectId, in_mediaEvent):
    SipCallEngineEvent.__init__(self, in_szDestObjectId)    
    t = TraceScope(fileScopeLogger,
               "JSR309Event.__init__")
    self.mediaEvent = in_mediaEvent
      
#
#  JSR309 Listener
# 
class JSR309Listener(PyMediaEventListener, InThreadCallbackImpl):
  def __init__(self, in_GlobalContext, in_EventProcessor):
    PyMediaEventListener.__init__(self)
    InThreadCallbackImpl.__init__(self, in_GlobalContext, in_EventProcessor)
    TraceScope(fileScopeLogger , "JSR309Listener.__init__")
    self._eventProcessorId  = in_EventProcessor.getId()

  def onEvent(self,in_event):
    PyLoggingFunctions.log_info(fileScopeLogger,"JSR309Listener::onEvent called with event %s",
             in_event);
    # Make a copy of the event and send it
    clonedEvent = in_event.clone()
    myEvent = JSR309Event(self._eventProcessorId,clonedEvent)

    # Enqueue it
    InThreadCallbackImpl.enqueuePythonEvent(self,myEvent)
## !!MIRROR FILE, DO NOT MODIFY!!
