
from paraxip.sipua.user.NetBorderApp import NetBorderApp
import netborderPyInfra
import paraxip.infra.PyLoggingFunctions as PyLoggingFunctions
from JSR309APICommonPythonModules import *
from JSR309ClientAPIPythonModules import *
from JSR309Sample.Call import Call
import os

fileScopeLogger = netborderPyInfra.Logger("netborder.JSR309Sample.App.py")

class App(NetBorderApp):
  def __init__(self):
    NetBorderApp.__init__(self)
    self._MsControlFactory = None
    self._MediaSesionFactory = None
    self._strAudiFilePath = None

  def onInviteGetCall(self, in_sipMessage):
    __pychecker__ = 'unusednames=in_sipMessage'
    """
    USER CONFIGURATION 
      Returns a tuple ([SM class:Class], [config:dict]) to tell which scenario \
      to run, and with what configuration.
    """
    
    return (Call, {
              "jsr309.enableSignalDetection":"True"              
            })

  def onStartup(self, in_refGlobalContext):
    NetBorderApp.onStartup(self, in_refGlobalContext)

    # Start JSR309 Server
    self._MsControlFactory = LocalMsControlFactory.getInstance()
    
    self._MsControlFactory.configure()
    self._MsControlFactory.start()

    self._MediaSessionFactory = self._MsControlFactory.\
                                createMediaSessionFactory()

    if self._MediaSessionFactory is None:
        PyLoggingFunctions.log_error(fileScopeLogger,"Cannot get a MediaSessionFactory")
        return False

    paraxip  = os.getenv("PARAXIP");
    self._strAudiFilePath = os.getenv("PARAXIP");
    
    return True

  def onShutdownCompleted(self):
    __pychecker__ = 'unusednames=t'
    t = netborderPyInfra.TraceScope(fileScopeLogger, 
                                    "NetBorderApp.onShutdownCompleted")
    # Stop JSR309 Server
    self._MsControlFactory.stop()
    self._MsControlFactory.waitUntilDone()
    return NetBorderApp.onShutdownCompleted(self)
    

  def getMediaSessionFactory(self):
    return self._MediaSessionFactory

  def getAudioFilePath(self):
    # All file are stored relative to the $PARAXIP environment variable
    # Only one call to os.getenv("PARAXIP") is done as it might 
    # be slow
    return self._strAudiFilePath

## !!MIRROR FILE, DO NOT MODIFY!!
