
from CommonApp import CommonApp
from SipCallEngineExtending import PyGetCallIdResult, CallConfigLoader 
import netborderPyInfra
import paraxip.infra.PyLoggingFunctions as PyLoggingFunctions
from JSR309APICommonPythonModules import *
from JSR309ClientAPIPythonModules import *
import os

# Call is a class part of the agent_bridge.Call module
import agent_bridge.DTMFEntryCall as Call

fileScopeLogger = netborderPyInfra.Logger(
    "netborder.AgentBridge.DTMFEntryApp.py")

class DTMFEntryApp(CommonApp):
  def __init__(self):
    CommonApp.__init__(self)
    

  def onStartup(self, in_refGlobalContext):
    if (not CommonApp.onStartup(self, in_refGlobalContext)):
      return False

    __pychecker__ = 'unusednames=t'
    t = netborderPyInfra.TraceScope(fileScopeLogger, 
        "DTMFEntryApp.onStartup")

    self._strAudioFilePath = os.getenv("PARAXIP_INSTALLDIR");
    self._strAudioFilePath += "/config/dtmf_agent_bridge/prompts"

    return True

  def onInviteGetCall(self, in_sipMessage):
    __pychecker__ = 'unusednames=in_sipMessage'
    """
    USER CONFIGURATION 
      Returns a tuple ([SM class:Class], [config:dict]) to tell which scenario \
      to run, and with what configuration.
    """

    # Retrieve default call parameters from the Call module ParameterInfoDB
    config = Call.DTMFEntryCall.getParameterInfoDB().getDefaultConfig()

    # Overidde default config values with values from calls properties file
    #  specified via global config param netborder.sip.ua.python.callsConfigURL
    fileConfig = CallConfigLoader.getConfigForCall('dtmf-entry')
    config.update(fileConfig)

    return (Call.DTMFEntryCall, config)
## !!MIRROR FILE, DO NOT MODIFY!!
