

from CommonApp import CommonApp
from SipCallEngineExtending import PyGetCallIdResult, CallConfigLoader 
import netborderPyInfra
import paraxip.infra.PyLoggingFunctions as PyLoggingFunctions
from JSR309APICommonPythonModules import *
from JSR309ClientAPIPythonModules import *
import os

# Call is a class part of the agent_bridge.Call module
import agent_bridge.XMLBasedEntryCall as Call

fileScopeLogger = netborderPyInfra.Logger(
    "netborder.AgentBridge.XMLBasedEntryApp.py")

class GetXMLTableAlarm(AlarmImpl):

    def __init__(self):
        AlarmImpl.__init__(self, error)

    def getName(self):
        return "Could not retrieve XML table for Agent SIP Server association"

    def getAlarmId(self):
        return self.getName() + " : Agent Bridge"


class XMLBasedEntryApp(CommonApp):
  def __init__(self):
    CommonApp.__init__(self)

  def onStartup(self, in_refGlobalContext):
    if (not CommonApp.onStartup(self, in_refGlobalContext)):
      return False

    __pychecker__ = 'unusednames=t'
    t = netborderPyInfra.TraceScope(fileScopeLogger, 
        "XMLBasedEntryApp.onStartup")

    self._strAudioFilePath = os.getenv("PARAXIP_INSTALLDIR");
    self._strAudioFilePath += "/config/xml_agent_bridge/prompts"

    # Set up the AlarmRegistry and add the GetRegistrarTableAlarm
    alarmRegistry = AlarmRegistry.getInstance()
    self._RegTblAlarmHandle = alarmRegistry.addAlarm(GetXMLTableAlarm())

    return True
  
  def onInviteGetCall(self, in_sipMessage):
    __pychecker__ = 'unusednames=in_sipMessage'
    """
    USER CONFIGURATION 
      Returns a tuple ([SM class:Class], [config:dict]) to tell which scenario \
      to run, and with what configuration.
    """

    # Retrieve default call parameters from the Call module ParameterInfoDB
    config = Call.XMLBasedEntryCall.getParameterInfoDB().getDefaultConfig()

    # Overidde default config values with values from calls properties file
    #  specified via global config param netborder.sip.ua.python.callsConfigURL
    fileConfig = CallConfigLoader.getConfigForCall('xml-entry')
    config.update(fileConfig)

    return (Call.XMLBasedEntryCall, config)

  def GetXMLTableAlarmHandle(self):
    # We can only have on instance of the Registrar Alarm in the application
    # It is acccessed here throught the application
    return self._RegTblAlarmHandle
## !!MIRROR FILE, DO NOT MODIFY!!
