#
#  @file   CpdResult.py
#  @author Francis Moreau
#  date    Mon August 13 2007
#
#  Copyright (C) 2007 Paraxip Technologies.
#  All Rights Reserved.
#

class CpdResult:
  """
  The CpdResult as they will appear to the client in the cpa-stats.csv file and SIP
  headers.
  
  @see http://intranet/pmwiki/pmwiki.php?n=Engineering.HeaderConvention#Preconnect
       ...for details.
  """
  
  Reject = 'Reject'
  AnsweringMachine = 'Answering-Machine'
  Unknown = 'Unknown'
  NoResult = 'NoResult'
  NoAnswer = 'No-Answer'  
  Voice = 'Voice'
  Fax = 'Fax'  
  Busy = 'Busy'
  InvalidNumber = 'Invalid-Number'
  ServiceUnavailable = 'Service-Unavailable'
  ReOrder = 'All-Trunks-Busy'
  AllTrunksBusy = 'All-Trunks-Busy'
  SipErrorGeneric = 'Reject'
  Sit_Temporary = 'Sit-Reorder'
  Sit_Permanent = 'Sit-Vacant'
  
  @classmethod
  def getListOfAllCpdResults(self):
    cpdResults = []
    for cpdResult in CpdResult.__dict__:
      if isinstance( basestring, cpdResult ):
        cpdResults.append( cpdResult )
    return cpdResults

## !!MIRROR FILE, DO NOT MODIFY!!
