
class CallDataConverterException(Exception):
  """
  The base class of all exceptions in this package (folder).
  """
  pass

class CallDataConverter:
  """
  Base class for all the converters in this folder.
  """
  
  def canYouHandle(self, in_instToConver, in_TypeToConvertTo):
    """
    @return {True: The class can convert 'in_instToConver' into 'in_TypeToConvertTo',
             False: it cannot.}
    """
    raise CallDataConverterException("Virtual abstract function")

  #@tag: Would really want to privatize in children
  def _convert(self, in_instToConver):
    raise CallDataConverterException("Virtual abstract function")
  
  def convert(self, in_instToConver, in_TypeToConvertTo):
    if not self.canYouHandle(in_instToConver, in_TypeToConvertTo):
      raise CallDataConverterException("Cannot convert types: (%s, %s)." %
                                       (in_instToConver, in_TypeToConvertTo))
    
    #Call the function defined in child
    return self._convert(in_instToConver)
  
## !!MIRROR FILE, DO NOT MODIFY!!
