
from paraxip.sipua.user.cpa.calldata_converter import CallDataConverter

from paraxip.sipua.user.cpa import CpaResult
from paraxip.sipua.user.cpa import CpdResult

class CpaResultToCpdResult(CallDataConverter.CallDataConverter):
  """
  @tag: This is a STRCpaResultToCpdResult. Maybe it should be clarified
        in class' name
  """
  
  __translationDict = {
  CpaResult.CpaResult.Human: CpdResult.CpdResult.Voice,
  CpaResult.CpaResult.AnsweringMachine: CpdResult.CpdResult.AnsweringMachine,
  CpaResult.CpaResult.NoResult: CpdResult.CpdResult.Unknown,
  CpaResult.CpaResult.Fax: CpdResult.CpdResult.Fax,
  CpaResult.CpaResult.Busy: CpdResult.CpdResult.Busy,
  CpaResult.CpaResult.ReOrder: CpdResult.CpdResult.AllTrunksBusy,
  CpaResult.CpaResult.SIT_Temporary: CpdResult.CpdResult.Sit_Temporary,
  CpaResult.CpaResult.SIT_Permanent: CpdResult.CpdResult.Sit_Permanent,
  CpaResult.CpaResult.Eamd_Beep: CpdResult.CpdResult.AnsweringMachine,
  CpaResult.CpaResult.Eamd_Silence: CpdResult.CpdResult.AnsweringMachine
  }
  
  def canYouHandle(self, in_instToConver, in_TypeToConvertTo):
    if isinstance(in_instToConver, basestring) and \
       isinstance(in_TypeToConvertTo, CpdResult.CpdResult):
      return True
    else:
      return False
  
  def _convert(self, in_szCpaResult):
    if CpaResultToCpdResult.__translationDict.has_key(in_szCpaResult):
      return CpaResultToCpdResult.__translationDict[in_szCpaResult]
    else:
      raise CallDataConverter.CallDataConverterException(
              "Invalid CPA result received: %s, cannot translate "
              "to Cpd-Result." % in_szCpaResult)

def test_module():
  c = CpaResultToCpdResult()
  cpdResult = c._convert(CpaResult.CpaResult.Human)
  assert cpdResult == CpdResult.CpdResult.Voice
  
  try:
    c._convert(1)
  except CallDataConverter.CallDataConverterException, e:
    print 'Received expected exception: %s' % e
  
  from paraxip.sipua.user.cpa import CallEvent  
  cpaR = CallEvent.Factory_CallCpaResult( CpaResult.CpaResult.ReOrder )
  converter = CpaResultToCpdResult()
  cpdR = converter._convert(cpaR.getStr())
  print cpdR
  assert cpdR == CpdResult.CpdResult.AllTrunksBusy
                       

if __name__ == '__main__':
  test_module()
## !!MIRROR FILE, DO NOT MODIFY!!
