import elixir
from datetime import datetime

##########
# Model
##########

class DNCPhoneNumber(elixir.Entity):

  elixir.using_options(tablename='phone_numbers')

  #NOTE Using the name as primary key would make the properties_values clearer,
  # but increases the db size (and may slow down joins)
  number = elixir.Field(elixir.Text, primary_key=True)
  comment = elixir.Field(elixir.UnicodeText)

  def __repr__(self):
    return '<DNCPhoneNumber: Number: %s, Comment: %s>' % \
      (self.number, self.comment)

##########
# Helpers
##########

def isPhoneNumberAcceptable(in_strPhoneNumber, in_strDBUri):
  # TODO do not re-bind and setup each time 
  elixir.metadata.bind = in_strDBUri
  elixir.setup_all()
  # Db must exists - TODO explicitly report error opening DB
  # NOTE sqlite will create a new empty file db even on error
  phoneNumber = DNCPhoneNumber.get_by(number=in_strPhoneNumber)
  if phoneNumber is None:
    return True # Not in DNC list
  else:
    return False # In DNC list

def createTestDB(in_strDBUri):
  elixir.metadata.bind = in_strDBUri
  elixir.setup_all()
  # Make sure we start with a new DB
  elixir.drop_all()
  elixir.create_all()

  DNCPhoneNumber(number='202', comment=u'source: Federal DNC list')

  elixir.session.flush()  
## !!MIRROR FILE, DO NOT MODIFY!!
