
from paraxip.sipua.user.NetBorderApp import NetBorderApp
from SipCallEngineExtending import PyGetCallIdResult
import netborderPyInfra

# DNCRedirectorCall is a class part of the dnc_redirector.DNCRedirectorCall module
from dnc_redirector.DNCRedirectorCall import DNCRedirectorCall

fileScopeLogger = netborderPyInfra.Logger("netborder.DNCRedirectorApp.py")

class DNCRedirectorApp(NetBorderApp):

  def onInviteGetCallId(self, in_sipMessage):
    """
    USER CONFIGURATION 
      Returns the SMCall call id to use as the call of the new dialog (in leg) 
      to be created. Giving the call id of an existing SMCall adds the new in leg
      to it, giving a new call-id creates a new SMCall, returning a SIP error code
      to rejects the call
    """
    __pychecker__ = 'unusednames=t,in_sipMessage'

    t = netborderPyInfra.TraceScope(fileScopeLogger, 
        "DNCRedirectorApp.onInviteGetCallId")

    return PyGetCallIdResult('NetBorder-Call-Id' + \
        netborderPyInfra.UUID().getAsString() + '.dnc')

  def onInviteGetCall(self, in_sipMessage):
    __pychecker__ = 'unusednames=in_sipMessage'
    """
    USER CONFIGURATION 
      Returns a tuple ([SM class:Class], [config:dict]) to tell which scenario \
      to run, and with what configuration.
    """
    return (DNCRedirectorCall,
            {
              'dnc.dburi': \
                'sqlite:///python-scripts/user/dnc_redirector/dnc_list.s3db',
              'sip.request.relay.server.address':'TODO',
              'sip.request.relay.server.port':TODO,
            })

## !!MIRROR FILE, DO NOT MODIFY!!
