#
#  @file   DNCRedirectorCall.py
#  
#  Description:
#
#  Type your description here
#
#  Copyright (C) 2008 Paraxip Technologies.
#  All Rights Reserved.
#

from paraxip.sipua.internal.SipCallEngineSMCall import *
from dnc_redirector.DNCRedirectorStates import *
import dnc_redirector.DNCListModel
import paraxip.infra.PyLoggingFunctions as PyLoggingFunctions
from netborderPyInfra import *

#
# dnc-redirector state machine
#

# Force declaration of class attributes in __init__ method
__pychecker__ = "initattr"

class DNCRedirectorCall(SipCallEngineSMCall):
  def __init__(self):
    __pychecker__ = 'unusednames=t'

    SipCallEngineSMCall.__init__(self)
    
    t = TraceScope(self.getLogger(), "DNCRedirectorCall.__init__")
    
    self.setLogger(CallLogger("netborder.dnc-redirector.call.py"))    

    # IDLE state
    idleState = IdleState(self)
    self.setInitialStateName(idleState.getName())
    self.setInitialState(idleState)

    # DISCONNECTED state
    disconnectedState = DisconnectedState(self)
    self.addFinalState(disconnectedState.getName(), disconnectedState)

  def scenarioName(self):
    return "Netborder DNC Redirector"

  def initialize(self, in_refApplication, in_refGlobalContext, in_szCallId):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(self.getLogger(), "DNCRedirectorCall.initialize")
    
    SipCallEngineSMCall.initialize(self,
                                   in_refApplication,
                                   in_refGlobalContext,
                                   in_szCallId)

    return True

  def reset(self):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(self.getLogger(),"DNCRedirectorCall.reset")

    SipCallEngineSMCall.reset(self)

  def isPhoneNumberAcceptable(self, in_strPhoneNumber):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(self.getLogger(), "DNCRedirectorCall.isPhoneNumberAcceptable")

    strDBUri = self.config['dnc.dburi']

    PyLoggingFunctions.log_debug(self.getLogger(), 
        "Checking if phone number %s is acceptable following DNC database at %s" % 
        (in_strPhoneNumber, strDBUri))

    try:
      return dnc_redirector.DNCListModel.isPhoneNumberAcceptable(in_strPhoneNumber,
          strDBUri)
    except Exception, e:
      PyLoggingFunctions.log_error(self.getLogger(), 'Error querying database \'%s\': %s' % \
          (strDBUri, str(e)))
      return True # Number is acceptable by default
## !!MIRROR FILE, DO NOT MODIFY!!
