#
#  Copyright (C) 2010 Sangoma Technologies.
#  All Rights Reserved.
#

from netborderPyInfra import TraceScope, CallLogger
import paraxip.infra.PyLoggingFunctions as PyLoggingFunctions

from paraxip.sipua.internal.SipCallEngineSMCall import SipCallEngineSMCall
from paraxip.sipua.internal.ParameterInfo import ParameterInfoDB

import paraxip.sipua.user.redirect.RedirectStates as RedirectStates 

# Force declaration of class attributes in __init__ method
__pychecker__ = "initattr"

class RedirectCall(SipCallEngineSMCall):

  # Valid parameter names for this Call
  PARAM_REDIRECT_CONTACT_HOST = 'redirect.contact.host'
  PARAM_REDIRECT_CONTACT_PORT = 'redirect.contact.port'

  # Provide parameter information for this Call 
  @staticmethod
  def getParameterInfoDB():

    parameterInfoDB = ParameterInfoDB()

    parameterInfoDB.addParameterInfoForName(
        RedirectCall.PARAM_REDIRECT_CONTACT_HOST,
        type=str,
        mandatory=True)
    parameterInfoDB.addParameterInfoForName(
        RedirectCall.PARAM_REDIRECT_CONTACT_PORT,
        type=int,
        mandatory=True)

    return parameterInfoDB

  def __init__(self):
    __pychecker__ = 'unusednames=t'

    SipCallEngineSMCall.__init__(self)
    
    t = TraceScope(self.getLogger(), "RedirectCall.__init__")
    
    self.setLogger(CallLogger("netborder.redirect.call.py"))    

    # IDLE state
    idleState = RedirectStates.IdleState(self)
    self.setInitialStateName(idleState.getName())
    self.setInitialState(idleState)

    # DISCONNECTED state
    disconnectedState = RedirectStates.DisconnectedState(self)
    self.addFinalState(disconnectedState.getName(), disconnectedState)
## !!MIRROR FILE, DO NOT MODIFY!!
