#
#  @file   Route.py
#  @author Francis Moreau
#  date    Wed June 11 2008
#  
#  Description:
#
#  Type your description here
#
#  Copyright (C) 2008 Paraxip Technologies.
#  All Rights Reserved.
#

import paraxip.infra.PyLoggingFunctions as PyLoggingFunctions
from paraxip.infra.Assert import *
import netborderPyInfra
from sip_router.RoutingConfig import RouteTo
from cStringIO import StringIO

fileScopeLogger = netborderPyInfra.Logger("netborder.sip-router.Route.py")

# Force declaration of class attributes in __init__ method
__pychecker__ = "initattr"

class Route:
  def __init__(self, in_routeToConfig, in_uiTimeoutMs):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "Route.__init__")

    self._routeToConfig = in_routeToConfig
    self._uiTimeoutMs = in_uiTimeoutMs

  def getRouteToConfig(self):
    return self._routeToConfig

  def getTimeoutMs(self):
    return self._uiTimeoutMs

  def __str__(self):
    strIOResult = StringIO()

    strIOResult.write("Route members:\n")

    strIOResult.write("%s" % (self._routeToConfig))
    strIOResult.write("Timeout in ms = %s\n" % (self._uiTimeoutMs))

    strResult = strIOResult.getvalue()
    strIOResult.close()
    return strResult

## !!MIRROR FILE, DO NOT MODIFY!!
