#
#  @file   RoutingSet.py
#  @author Francis Moreau
#  date    Wed June 11 2008
#  
#  Description:
#
#  Type your description here
#
#  Copyright (C) 2008 Paraxip Technologies.
#  All Rights Reserved.
#

import paraxip.infra.PyLoggingFunctions as PyLoggingFunctions
from paraxip.infra.Assert import *
import netborderPyInfra
from sip_router.Route import Route
from cStringIO import StringIO

fileScopeLogger = netborderPyInfra.Logger(
  "netborder.sip-router.RouteSet.py")

# Force declaration of class attributes in __init__ method
__pychecker__ = "initattr"

class RouteSet:
  def __init__(self):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "RouteSet.__init__")

    self._dictRoutes = {}

  def size(self):
    return len(self._dictRoutes)

  def addRoute(self, in_route):
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "RouteSet.addRoute")

    # TODO: Take server address + server port has key
    strDestServerAddr = in_route.getRouteToConfig().serverAddress
    if (isLogAssert(fileScopeLogger, strDestServerAddr is not None)):
      return
    if (isLogAssert(fileScopeLogger, strDestServerAddr not in self._dictRoutes)):
      return

    self._dictRoutes[strDestServerAddr] = in_route

  def getIterator(self):
    """
    rs = RouteSet()
    it = rs.getIterator()
    for route in it:
      print route
    it.close()
    """
    __pychecker__ = 'unusednames=t'
    t = TraceScope(fileScopeLogger, "RouteSet.getIterator")

    if (len(self._dictRoutes) > 0):
      for route in self._dictRoutes.itervalues():
        yield route

  def __str__(self):
    strIOResult = StringIO()

    strIOResult.write("RouteSet members:\n")

    for route in self._dictRoutes.itervalues():
      strIOResult.write("%s" % (route))

    strResult = strIOResult.getvalue()
    strIOResult.close()
    return strResult

## !!MIRROR FILE, DO NOT MODIFY!!
